<template>
   <div class="modal d-flex align-items-center row m-0">
       <div class="container col-6 bg-light rounded table-responsive p-3 shadow">
            <form @submit.prevent class="form">
                <h3 class="text-center mb-5">Редактирование клиента</h3>
                <edit-table :items="inputItems"></edit-table>
                <div class="mt-3 cust-heihgt  m-auto">
                    <transition name="fade">
                        <p v-show="isShow" class="bg-success text-white p-2 text-center rounded shadow">Запись успешно изменена!</p>
                    </transition>
                </div>
                <div class="d-flex justify-content-end">
                    <button-send-form :disabled="isDisabled" @click="editData" class="btn-primary mx-2"><i class="fa fa-edit"></i> Изменить</button-send-form> 
                    <router-link :to="{name: 'clients'}" class="btn btn-secondary">Закрыть</router-link>
                </div>                
            </form>
        </div>
    </div>
</template>

<script>
import {ref, onMounted, computed} from 'vue';
import { useStore } from 'vuex'
import {useRouter, useRoute } from 'vue-router';
import {mapActions, mapGetters, mapMutations} from 'vuex';

export default {
    setup(){
        const store = useStore();
        const router = useRouter();
        const route = useRoute();
        const isDisabled = ref(false)
        const listLoad = ref([]);
        const isShow = ref(false);

        const inputItems = computed(() => store.getters.CLIENT_INPUT_ITEMS);

        const listItems = computed(() => store.getters.LIST_ITEMS);
        
        onMounted(()=> {
            loadData();
        });

        function loadData(){
            listItems.value.forEach(el => {
                if(el.id == route.params.id){
                    inputItems.value.forEach(element =>{
                        element.value = el[element.name]
                    });

                } 
            });
        }

        function editData(){

            isDisabled.value = true;

            const arr = [];           
            
            inputItems.value.forEach(el => 
               
                arr[el.name] = el.value,
                arr['id'] =  route.params.id,
            )
            
            listItems.value.forEach((element, index) => {
                if(element.id == route.params.id){
                    listItems.value.splice(index, 1, {...arr})
                }
            });
  
            showMessage(inputItems.value, 'clients');            
        }

        function showMessage(arr,rout){
            isShow.value = !isShow.value;
            setTimeout(() => {
                isShow.value = !isShow.value;
                router.push({name: rout});
                arr.forEach(el => 
                   el.value = ''
                )
            }, 1000); 
        }

        return {
            isDisabled,
            inputItems,
            isShow,
            editData
        }
    }
    
    // data(){
    //     return {
    //         inputItems: [],
    //         listItems: [],
    //         listLoad:[],
    //     }
    // },
    // mounted(){
    //     this.inputItems = this.$store.state.entryData.inputItems;
    //     this.listItems = this.$store.state.entryData.listItems;
    //     this.loadData();
    // },
    // methods: {
    //     loadData(){
    //         this.listItems.forEach(el => {
    //             if(el.id == this.$route.params.id){
    //                 this.inputItems.forEach(element =>{
    //                     element.value = el[element.name]
    //                 })
    //             } 
    //         });
    //     },
    //     editData(){
    //         this.isDisabled = true;
    //         const data = [];           
         
    //         this.inputItems.forEach(el => 
                
    //             data[el.name] = el.value,
    //             data['id'] =  this.$route.params.id
    //         )

    //         this.$store.state.entryData.listItems.forEach((element, index) => {
    //             if(element.id == this.$route.params.id){
    //                 this.$store.state.entryData.listItems.splice(index, 1, data)
    //             }
    //         });
       
    //         this.showMessage(this.inputItems, 'clients');            
    //     },
    //     showMessage(arr,rout){
    //         this.isShow = !this.isShow;
    //         setTimeout(() => {
    //         this.isShow = !this.isShow;
    //         this.$router.push({name: rout});
    //         this.clearFields(arr);
    //         }, 1000); 
    //     },
    //     clearFields(arr){
    //         arr.forEach(el => 
    //             el.value = ''
    //         )
    //     }
    // }
}
</script>

<style>

</style>
